import cookies from "js-cookie";

export const getUserFromCookie = async () => {
    const cookie = cookies.get("auth");
    if (!cookie) {
        return null;
    }
    return JSON.parse(cookie);
};

export const setUserCookie = (user) => {    
    cookies.set("auth", JSON.stringify(user), {
        //Enter significa dies. Si es fan divisions passen a hores
        //Si s'omet es converteix en galeta de sessió.
        expires: 1 / 24, //1 hora
    });
};

export const removeUserCookie = () => cookies.remove("auth");
