
import { useState } from "react";
import { Form } from "react-bootstrap";

import { toast } from "react-toastify";
import useUserContext from "../../../../../contexts/UserContext";
import { useForm } from "../../../../../Hooks/useForm";
import { GeneralModal } from "../../../../formulari/GeneralModal";
import { Button } from "../../../../globals/Button";

export const ModalDades = ({
    account: { email, admin },
    entity: { displayName, address, postCode, city, country, phone },
}) => {
    
    const { user } = useUserContext();

    const changeInput = (e) => {
        handleInputChange(e);
        if (formValidated) {
            setformValidated(false);
        }
    };
    const handleSubmit = (e) => {
        //Es carreguen al apretar submit per si hi ha
        //canvi de token en el inpass del modal
        const token = user?.token ?? false;
        const url = `/api/data/entity`;
        const SendData = async () => {
            fetch(url, {
                method: "PUT",
                headers: {
                    Accept: "application/json, text/plain, */*",
                    "Content-Type": "application/json",
                    token
                },
                body: JSON.stringify({ data: formValues }),
            })
                .then((resp) => resp.json())
                .then((data) => {
                    if (!!data.accion) {
                        toast.info("S'ha actualitzat correctament!");
                    } else {
                        toast.error("No s'ha pogut actualitzar!");
                    }
                })
                .catch((err) => {
                    toast.error("No s'ha pogut actualitzar!");
                });
        };
        const form = e.currentTarget;
        e.preventDefault();
        e.stopPropagation();

        //Comprovar la validesa del formulari
        form.checkValidity() ? SendData() : setformValidated(true);
    };

    const [formValidated, setformValidated] = useState(false);

    const [formValues, handleInputChange /*,reset*/] = useForm({
        email,
        displayName,
        address,
        postCode,
        city,
        country,
        phone,
    });

    return (
        <>
            <Form noValidate validated={formValidated} onSubmit={handleSubmit}>
                <p className="text-center font-weight-bold">
                    Informació de contacte
                </p>
                <GeneralModal
                    // changeInput={changeInput}
                    id={"email"}
                    label={"Usuari"}
                    name={"email"}
                    value={formValues?.email}
                    type={"email"}
                    readOnly
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"displayName"}
                    label={"Àlies"}
                    name={"displayName"}
                    value={formValues?.displayName}
                    type={"text"}
                    required
                    readOnly={!admin}
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"address"}
                    label={"Adreça"}
                    name={"address"}
                    value={formValues?.address}
                    type={"text"}
                    readOnly={!admin}
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"postCode"}
                    label={"C.Postal"}
                    name={"postCode"}
                    value={formValues?.postCode}
                    type={"text"}
                    readOnly={!admin}
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"city"}
                    label={"Ciutat"}
                    name={"city"}
                    value={formValues?.city}
                    type={"text"}
                    readOnly={!admin}
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"country"}
                    label={"País"}
                    name={"country"}
                    value={formValues?.country}
                    type={"text"}
                    readOnly={!admin}
                />
                <GeneralModal
                    changeInput={changeInput}
                    id={"phone"}
                    label={"Telefon"}
                    name={"phone"}
                    value={formValues?.phone}
                    type={"text"}
                    readOnly={!admin}
                />
                <Form.Row
                    className="d-flex justify-content-center"
                    style={{ marginTop: "25px" }}
                >
                    {admin && <Button type="submit">Guardar</Button>}
                </Form.Row>
            </Form>
        </>
    );
};
