import firebase from "firebase/app";

import { toast } from "react-toastify";
import { Button } from "../../../../globals/Button";

export const ModalPassword = ({ account:{ email } }) => {
   
    const handleClick = () => {
        firebase
            .auth()
            .sendPasswordResetEmail(email)
            .then(toast.info(`Correu enviat correctament a ${email || ""}`))
            .catch((error) => {
                console.error(error);
                toast.info(`No s'ha pogut enviar el correu a ${email || ""}`);
            });        
    };

    return (
        <>
            <p className="text-center font-weight-bold">Canvi paraula de pas</p>
            <p className="text-justify">
                El canvi de la paraula de pas s&lsquo;ha de fer a través
                d&lsquo;un enllaç que s&lsquo;enviarà al correu electrònic del
                compte. Seguiu les instruccions que allà es detallen.
            </p>
            <p className="text-justify">
                Si no observes el missatge a la safata d&lsquo;entrada, potser
                hauries de fer un cop d&lsquo;ull a la carpeta d&lsquo;SPAM
            </p>
            <p>Vols enviar ara el correu?</p>
            <div
                className="d-flex justify-content-center"
                style={{ marginTop: "25px" }}
            >
                <Button onClick={handleClick}>Enviar correu</Button>
            </div>
        </>
    );
};
