/**
 * state --> 0 carrega llista subcomtes
 * state --> 1 edita la subcompte seleccionada
 * state --> 2 formulari crear un subcomte nou
 *
 */

import React, { useEffect, useState } from "react";
import useUserContext from "../../../../../contexts/UserContext";
import { useFetch } from "../../../../../Hooks/useFetch";
import { ModalObjectsEdit } from "./ModalObjectsEdit";
import { ModalObjectsTable } from "./ModalObjectsTable";

export const ModalObjects = ({ account }) => {
    const [stateobj, setstateobj] = useState(0);
    const [objectedit, setobjectedit] = useState({});
    const { user } = useUserContext();
    const [objects, setobjects] = useState();

    const token = user?.token ?? false;
    const url = `/api/data/objects`;
    const { data, loading, error } = useFetch({ url, token });

    useEffect(() => {
        setobjects({ objects: data?.data });
    }, [data]);

    return (
        <div className="subAccount">
            {stateobj == 0 && (
                <ModalObjectsTable
                    setstateobj={setstateobj}
                    setobjectedit={setobjectedit}
                    setobjects={setobjects}
                    data={objects}
                    loading={loading}
                />
            )}

            {[1, 2].includes(stateobj) && (
                <ModalObjectsEdit
                    stateobj={stateobj}
                    setstateobj={setstateobj}
                    objectedit={objectedit}
                    setobjects={setobjects}
                />
            )}
            {![0, 1, 2].includes(stateobj) && (
                <h3>
                    Alguna cosa ha fallat, no es poden carregar les dades,
                    recarregui
                </h3>
            )}
        </div>
    );
};
