/**
 * state --> 0 carrega llista subcomtes
 * state --> 1 edita la subcompte seleccionada
 * state --> 2 formulari crear un subcomte nou
 *
 */

import React, { useEffect, useState } from "react";
import useUserContext from "../../../../../contexts/UserContext";
import { useFetch } from "../../../../../Hooks/useFetch";

import { ModalSubAccountEdit } from "./ModalSubAccountEdit";
import { ModalSubAccountTable } from "./ModalSubAccountTable";

export const ModalSubAccount = ({ account }) => {
    const [statesub, setstatesub] = useState(0);
    const [subaccountedit, setsubaccountedit] = useState({});
    const { user } = useUserContext();
    const [accounts, setaccounts] = useState();

    const token = user?.token ?? false;
    const url = `/api/data/subaccounts`;
    const { data, loading, error } = useFetch({url,token});

    useEffect(() => {              
        setaccounts({subaccounts:data?.data});        
    }, [data]);

    return (
        <div className="subAccount">
            {statesub == 0 && (
                <ModalSubAccountTable
                    setstatesub={setstatesub}
                    setsubaccountedit={setsubaccountedit}                   
                    setaccounts={setaccounts}
                    data={accounts}
                    loading={loading}
                />
            )}

            {[1, 2].includes(statesub) && (
                <ModalSubAccountEdit
                    statesub={statesub}
                    setstatesub={setstatesub}
                    subaccountedit={subaccountedit}
                    setaccounts={setaccounts}
                />
            )}
            {![0, 1, 2].includes(statesub) && (
                <h3>
                    Alguna cosa ha fallat, no es poden carregar les dades,
                    recarregui
                </h3>
            )}
        </div>
    );
};
