import React, { useState } from "react";

import { Form } from "react-bootstrap";
import { GeneralModal } from "../../../../formulari/GeneralModal";
import { Button } from "../../../../../components/globals/Button";
import { useForm } from "../../../../../Hooks/useForm";

import { toast } from "react-toastify";
import useUserContext from "../../../../../contexts/UserContext";

export const ModalSubAccountEdit = ({
    statesub,
    setstatesub,
    subaccountedit,
    setaccounts,
}) => {
    const [formValidated, setformValidated] = useState(false);
    const { user } = useUserContext();

    const handleSubmit = (e) => {
        e.preventDefault();
        e.stopPropagation();
        //Es carreguen al apretar submit per si hi ha
        //canvi de token en el inpass del modal
        const token = user?.token ?? false;
        const url = `/api/data/subaccounts`;
        const SendData = async () => {
            fetch(url, {
                method: statesub == 1 ? "PUT" : "POST",
                headers: {
                    Accept: "application/json, text/plain, */*",
                    "Content-Type": "application/json",
                    token
                },
                body: JSON.stringify({ data: formValues }),
            })
                .then((resp) => resp.json())
                .then((data) => {
                    if (!!data.accion) {                            
                        const userMongo = data?.data;                        
                        if (statesub == 2) {
                            setaccounts((prevState) => ({
                                subaccounts: [
                                    ...prevState.subaccounts,
                                    userMongo,
                                ],
                            }));
                        } else {                           
                            setaccounts((prevState) => ({
                                subaccounts: prevState?.subaccounts.map((el) => {
                                    if (el?._id === userMongo?._id) {                                          
                                        return {
                                            ...el,
                                            admin: userMongo.admin,
                                            displayName:
                                            userMongo.displayName,
                                            active:userMongo.active,
                                        };
                                    } else {
                                        return el;
                                    }
                                }),
                            }));
                        }
                        toast.info("S'ha actualitzat correctament!");
                    } else {                        
                        toast.error("No s'ha pogut actualitzar!");
                    }
                })
                .catch((err) => {
                    toast.error("No s'ha pogut actualitzar!");
                });
        };

        const form = e.currentTarget;

        //Comprovar la validesa del formulari
        form.checkValidity() ? SendData() : setformValidated(true);
        setstatesub(0);
    };

    const [formValues, handleInputChange /*,reset*/] = useForm({
        _id: subaccountedit._id,
        idEntity: subaccountedit.idEntity,
        cemail: subaccountedit.email,
        email: subaccountedit.email,
        displayName: subaccountedit.displayName,
        // main: subaccountedit.main,
        admin: subaccountedit.admin,
        active: subaccountedit.active,
    });

    const changeInput = (e) => {
        handleInputChange(e);
        if (formValidated) {
            setformValidated(false);
        }
    };

    return (
        <Form noValidate validated={formValidated} onSubmit={handleSubmit}>
            <p className="text-center font-weight-bold">
                Gestió de comptes secundaris
            </p>
            <GeneralModal
                changeInput={changeInput}
                id={"email"}
                label={"Correu"}
                name={"email"}
                value={formValues?.email}
                type={"email"}
                readOnly={statesub == 1}
            />
            {statesub == 2 && (
                <GeneralModal
                    changeInput={changeInput}
                    id={"cemail"}
                    placeholder={"Confirma Correu"}
                    label={"Correu"}
                    name={"cemail"}
                    value={formValues?.cemail}
                    type={"email"}
                />
            )}
            <GeneralModal
                changeInput={changeInput}
                id={"displayName"}
                placeholder={"Display Name"}
                label={"Name"}
                name={"displayName"}
                value={formValues?.displayName}
                type={"text"}
            />
            {/* <GeneralModal
                changeInput={changeInput}
                id={"main"}
                label={"Main"}
                name={"main"}
                checked={formValues?.main}
                type={"checkbox"}
                
            /> */}
            <GeneralModal
                changeInput={changeInput}
                id={"admin"}
                label={"Admin"}
                name={"admin"}
                checked={formValues?.admin}
                type={"checkbox"}
            />
            {statesub == 1 && (
                <GeneralModal
                    changeInput={changeInput}
                    id={"active"}
                    label={"Active"}
                    name={"active"}
                    checked={formValues?.active}
                    type={"checkbox"}
                />
            )}
            <Form.Row
                className="d-flex justify-content-center"
                style={{ marginTop: "25px" }}
            >
                <Button type="submit">
                    {statesub == 1 ? "Actualitzar" : "Crear"}
                </Button>
                <div className="ml-3">
                    <Button  type="button" onClick={() => setstatesub(0)}>Tornar</Button>
                </div>
            </Form.Row>
        </Form>
    );
};
