import React from "react";
import Form from "react-bootstrap/Form";

export const GeneralModal = (props) => {
    const {
        changeInput,
        value,
        id,
        name,
        label,
        type,
        readOnly,
        placeholder,
        required,
        checked = false,
        step = 1,
        as,
        rows=3
    } = props;

    return (
        <Form.Row className="mt-2">
            <Form.Group className="col-md-12 mb-0 d-flex">
                {!!label && (
                    <Form.Label
                        htmlFor={id}
                        style={{
                            fontSize: "1em",
                            minWidth: "4.2em",
                        }}
                        className="mt-1 mr-2"
                    >
                        {label ? label : ""}
                    </Form.Label>
                )}
                <Form.Control
                    autoComplete="off"
                    className="form-control w-100"
                    id={id}
                    name={name}
                    onChange={changeInput}
                    placeholder={placeholder ? placeholder : label}
                    required={required}
                    type={type}
                    defaultValue={value}
                    readOnly={readOnly}
                    checked={checked}
                    step={step}
                    as={as}
                    rows={rows}
                />

                <Form.Control.Feedback type="invalid">
                    {type === "number" && "Aquest camp només pot tenir números"}
                    {type === "password" && "Aquest camp no pot estar en blanc"}
                    {type === "text" && "Aquest camp no pot estar en blanc"}
                </Form.Control.Feedback>
            </Form.Group>
        </Form.Row>
    );
};
