import React from "react";
import Form from "react-bootstrap/Form";

export const Password = (props) => {
    const { changeInput, value, id, name, label } = props;

    const patternPass =
        "^(?=.*\\d)(?=.*[\\u0021-\\u002b\\u003c-\\u0040])(?=.*[A-Z])(?=.*[a-z])\\S{6,15}$";

    return (
        <Form.Row className="mt-2">
            <Form.Group className="col-md-12">
                <Form.Label
                    htmlFor={id}
                    style={{
                        fontSize: "1.2em",
                    }}
                >
                    {label ? label : "Paraula de pas"}
                </Form.Label>
                <Form.Control
                    aria-describedby="password"
                    autoComplete="off"
                    className="form-control"
                    id={id}
                    name={name}
                    onChange={changeInput}
                    placeholder={"Paraula de pas"}
                    pattern={patternPass}
                    required
                    type={"password"}
                    value={value}
                />
                <Form.Control.Feedback type="invalid">
                    {value === ""
                        ? "Aquest camp no pot estar en blanc"
                        : "La contrasenya ha de tenir entre 8 i 16 caràcters, mínim un dígit, almenys una minúscula, almenys una majúscula i almenys un caràcter especial."}
                </Form.Control.Feedback>
            </Form.Group>
        </Form.Row>
    );
};
