import React from "react";
import { Form, InputGroup } from "react-bootstrap";

export const UserNameModal = (props) => {
    const { changeInput, value, id, name, label } = props;

    const patternEmail =
        "^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$";

    return (
        <Form.Row className="mt-3">
            <Form.Group className="col-md-12 mb-0" >
                <Form.Label
                    htmlFor="email"
                    style={{
                        fontSize: "1em",
                    }}
                >
                    {label ? label : "Direcció de correu"}
                </Form.Label>
                <InputGroup>
                    <InputGroup.Prepend>
                        <InputGroup.Text>@</InputGroup.Text>
                    </InputGroup.Prepend>
                    <Form.Control
                     
                        aria-describedby="inputGroupUsername"
                        autoComplete="off"
                        className="form-control"                        
                        id={id}
                        name={name}
                        onChange={changeInput}
                        pattern={patternEmail}                        
                        type="email"
                        value={value.toLowerCase()}
                       
                    />
                    <Form.Control.Feedback type="invalid">
                        {value === ""
                            ? "Aquest camp no pot estar en blanc"
                            : "Introdueixi una adreça de correu electrònic vàlida"}
                    </Form.Control.Feedback>
                </InputGroup>
            </Form.Group>
           
        </Form.Row>
    );
};
