import { colors } from "../../styles/theme";
import React from "react";

export const Button = React.forwardRef(({ children, onClick, href,type }, ref) => {
    return (
        <>
            <button href={href} ref={ref} onClick={onClick} type={type}>
                {children}
            </button>
            <style jsx>{`
                button {
                    align-items: center;
                    background: ${colors.primaryBlue};
                    border-radius: 9999px;
                    border: 0;
                    color: ${colors.textButton};
                    cursor: pointer;
                    display: flex;
                    font-weight: 600;
                    padding: 8px 24px;
                    transition: opacity 0.2s ease;
                }
                button:hover {
                    opacity: 0.8;
                }
            `}</style>
        </>
    );
});

//Evitar error de display name amb React.
Button.displayName = 'customButton';