
import React from "react";
import Modal from 'react-bootstrap/Modal'
import { Button } from "./Button";
import { useRouter } from 'next/router'


export const ModalClose = (props) => {


    const {show,setshow,title,text,route,...otherProps} = props

    const handleClose = () => {            
        setshow(false)
        if(!!(route)) router.push(route)
    };
    // const handleShow = () => setshow(true);
    
    const router = useRouter()

    return (
        <>        
            <Modal
                {...otherProps }
                show={show} 
                onHide={handleClose} 
                animation={false}     

            >
                <Modal.Header
                    closeButton={false}                    
                >
                    <Modal.Title>{title}</Modal.Title>
                </Modal.Header>
                <Modal.Body>
                    <p>{text}</p>
                </Modal.Body>
                <Modal.Footer>
                    <Button onClick={handleClose}>
                        Cerrar
                    </Button>                    
                </Modal.Footer>
            </Modal>
        </>
    );
};


