import React from "react";

const Spinner = (props) => {
    const { colorspinner, colorText, text/*, visibility*/ } = props;

    return (
        <div id="root">
            <div className="divLoader">
                <svg
                    className="svgLoader"
                    viewBox="0 0 100 100"
                    width="10em"
                    height="10em"
                    {...props}
                >
                    <text x={30} y={55} fontSize="1em" color={colorText}>
                        {text}
                    </text>
                    <path
                        ng-attr-d="{{config.pathCmd}}"
                        ng-attr-fill="{{config.color}}"
                        stroke="none"
                        d="M10 50A40 40 0 0 0 90 50A40 42 0 0 1 10 50"
                        fill={colorspinner}
                        transform="rotate(179.719 50 51)"
                    >
                        <animateTransform
                            attributeName="transform"
                            type="rotate"
                            calcMode="linear"
                            values="0 50 51;360 50 51"
                            keyTimes="0;1"
                            dur="1s"
                            begin="0s"
                            repeatCount="indefinite"
                        />
                    </path>
                </svg>
            </div>

            <style jsx>{`
                .svgLoader {
                    animation: spin 0.5s linear infinite;
                    margin: auto;
                }
                .divLoader {
                    display: flex;
                    align-items: center;
                    justify-content: center;
                    z-index: 9999;
                }
                @keyframes spin {
                    0% {
                        transform: rotate(0deg);
                    }
                    100% {
                        transform: rotate(360deg);
                    }
                }
            `}</style>
        </div>
    );
};

export default Spinner;
