import React from 'react'
import { colors } from "../../styles/theme";

const TitleSVG = React.forwardRef((props, ref) => {

    let { color1, color2 } = props;
    
    color1 = (color1) || colors.title
    color2 = (color2) || colors.primaryBlue

    return (
        <svg
            ref={ref}
            viewBox="0 0 170 70"
            xmlns="http://www.w3.org/2000/svg"
            {...props}
        >
            <style>{".prefix__heavy{font:700 30px sans-serif}"}</style>
            <text x={20} y={35} className="prefix__heavy" fill={color1}>
                {"Police"}
            </text>
            <text x={65} y={56} className="prefix__heavy" fill={color2}>
                {"Tracker"}
            </text>
        </svg>
    );
});

//Evitar error de display name amb react
TitleSVG.displayName = "TitleSVG";

export default TitleSVG;


