import "firebase/auth";
import { useForm } from "../../Hooks/useForm";
import { Button } from "../globals/Button";
import firebase from "firebase/app";
import Form from "react-bootstrap/Form";
import Link from "next/link";
import styles from "../../styles/Login.module.css";
import { useState } from "react";
import { ModalClose } from "../globals/ModalClose";
import { UserName } from "../formulari/UserName";
import { General } from "../formulari/General";
import Spinner from "../globals/Spinner";
import { colors } from "../../styles/theme";

export const CardLogin = () => {
    const changeInput = (e) => {
        handleInputChange(e);
        if (formValidated) {
            setformValidated(false);
        }
    };

    const signInWithEmailPassword = () => {
        // [START auth_signin_password]
        document.getElementById("spinner").style.visibility = "visible";
        firebase
            .auth()
            .signInWithEmailAndPassword(email, password)
            .then(async ({ user }) => {
                //SIGNED
                console.info("Login succes");
            })
            .catch((error) => {
                // NOT SIGNED
                console.log(error);
                setshow(true);
                document.getElementById("spinner").style.visibility = "hidden";
            });
        // [END auth_signin_password]
    };

    const handleSubmit = (e) => {
        const form = e.currentTarget;
        e.preventDefault();
        e.stopPropagation();

        //Comprovar la validesa del formulari
        form.checkValidity()
            ? signInWithEmailPassword()
            : setformValidated(true);
    };

    const initialForm = {
        email: "",
        password: "",
    };

    const [show, setshow] = useState(false);

    const [formValidated, setformValidated] = useState(false);

    const [formValues, handleInputChange /*,reset*/] = useForm(initialForm);

    const { email, password } = formValues;

    return (
        <div className={styles.card}>
            <h2 className={styles.h2}>Inici de sessió</h2>
            <Form noValidate validated={formValidated} onSubmit={handleSubmit}>
                <UserName
                    id={"email"}
                    name={"email"}
                    changeInput={changeInput}
                    email={email}
                />
                <General
                    id={"password"}
                    name={"password"}
                    changeInput={changeInput}
                    value={password}
                    type={"password"}
                    label={"Paraula de pas"}
                />
                <Form.Row className="mt-1 col-md-12">
                    <Link href="/forgotPassword">
                        <a style={{ textDecoration: "none" }}>
                            Has oblidat la contrasenya?
                        </a>
                    </Link>
                </Form.Row>
                <Form.Row
                    className="d-flex justify-content-center"
                    style={{ marginTop: "20px" }}
                >
                    <Button type="submit">Login</Button>
                </Form.Row>
            </Form>
            <ModalClose
                centered
                setshow={setshow}
                show={show}
                title={"Error de login"}
                text={"L'usuari i/o la contrasenya no són correctes"}
            />
            <div
                id="spinner"
                style={{ visibility: "hidden" }}
                className={styles.spinnerDiv}
            >
                <Spinner colorspinner={colors.primaryBlue} />
            </div>
        </div>
    );
};
