import styles from "../../styles/Login.module.css";
import Link from "next/link";
import { Button } from "../globals/Button";

export const CardRegister = () => {
    return (
        <div className={styles.card}>
            <div>
                <h2 className={styles.h2}>Registre</h2>

                <p>Encara no tens compte?</p>
                <p> Crea&lsquo;n un.</p>

                <label
                    hyphens="none"
                    className="mt-4"
                    style={{
                        fontSize: "0.8em",
                        textAlign: "justify",
                    }}
                >
                    Ens confieu la vostra informació, per això, treballem per
                    protegir les vostres dades i perquè en tingueu el control.
                </label>
                <label
                    hyphens="none"
                    className="mb-3"
                    style={{
                        fontSize: "0.8em",
                        textAlign: "justify",
                    }}
                >
                    L&lsquo;objectiu d&lsquo;aquesta {"  "}
                    <Link href="/privacyPolicy" passHref>
                        <a>Política de privadesa</a>
                    </Link>
                    {"  "}
                    és informar de quina informació recopilem, per què la
                    recopilem i com podeu actualitzar, gestionar, exportar i
                    suprimir les vostres dades.
                </label>
                <div
                    className="mt-2 d-flex justify-content-center"                    
                >
                    <Link href="/signUp" passHref>
                        <Button>Registrar-se</Button>
                    </Link>
                </div>
            </div>
        </div>
    );
};
