import styles from "../../styles/Login.module.css";
import Image from "next/image";
import Link from "next/link";

export const Footer = () => {
    return (
        <footer className={styles.footer}>
            <div className={styles.preFooter} />
            <div className={styles.corporateContainer}>
                <div className={styles.corporateLink}>
                    <Link href="/privacyPolicy">
                        <a
                            target="_blank"
                            className={styles.footerLink}
                            rel="noopener noreferrer"
                        >
                            Politica de privadesa
                        </a>
                    </Link>
                    <Link href="/">
                        <a
                            target="_blank"
                            className={styles.footerLink}
                            rel="noopener noreferrer"
                        >
                            Cookies
                        </a>
                    </Link>
                    <Link href="/">
                        <a
                            target="_blank"
                            className={styles.footerLink}
                            rel="noopener noreferrer"
                        >
                            Contacta&lsquo;ns
                        </a>
                    </Link>
                </div>
                <div className={styles.logoContainer}>
                    <div className="logo">
                        <Image
                            width="100pt"
                            height="100pt"
                            src="/logo.svg"
                            alt=""
                        />
                    </div>
                </div>
                <div className="copyrightLink">
                    <p>© 2021 - PolTracker - by Rulomo</p>
                </div>
            </div>
        </footer>
    );
};
