import { FeatureGroup, useMap } from "react-leaflet";
import "leaflet-geosearch/dist/geosearch.css";
import { EditControl } from "react-leaflet-draw";
import { useState } from "react";
import { ModalZona } from "../../customModals/ModalZona/ModalZona";

const DrawControl = () => {
    const map = useMap();

    const [show, setshow] = useState(false);
    const [mark, setmark] = useState({});

    map.on(L.Draw.Event.CREATED, function (e) {
        
        let layerType = e?.layerType;
        let m = e.layer;
        m.layerType = layerType;
        let btn = document.createElement("a");
        btn.style.cursor = "pointer";
        btn.innerText = "💾";
        //Poder tancar-ho
        btn.onclick = (el) => {
            setmark(m);
            setshow(true);
        };


        m.bindPopup(btn, {
            maxWidth: "auto",
        }).openPopup();
        /////
    });

    return (
        <>
            <FeatureGroup>
                <EditControl
                    position="bottomleft"                   
                    draw={{
                        marker: true,
                        circlemarker: false,
                        polyline: true,
                        polygon: true,
                        circle: true,
                        rectangle: true,
                    }}
                    edit={{ edit: true, remove: true }}
                />
            </FeatureGroup>
            {!!show && (
                <ModalZona
                    setshow={setshow}
                    show={show}
                    mark={mark}
                    setmark={setmark}
                    isNew={true}
                    title={"Edició zones"}
                />
            )}
        </>
    );
};

export default DrawControl;
