import { useMap } from "react-leaflet";

import { useEffect, useState } from "react";
import { ModalServices } from "../../customModals/ModalServices/ModalServices";

const Maplibs = () => {
    const [service, setservice] = useState();
    const [latlng, setlatlng] = useState([]);

    const contextItems = [
        {
            text: "Crear Servei aquí",
            callback: newService,
        },
        {
            text: "Crear Marca aquí",
            callback: zoomIn,
        },

        "-",
        {
            text: "Zoom in",
            callback: zoomIn,
        },
        {
            text: "Zoom out",
            callback: zoomOut,
        },
        "-",
        {
            text: "Mostrar Coordenades",
            callback: (e) => alert(e.latlng),
        },
        {
            text: "Centrar aquí",
            callback: centerMap,
        },
        "-",
        {
            text: "Google Maps",
            callback: googleMaps,
        },
        {
            text: "Google Street View",
            callback: streeView,
        },
    ];

    function newService(e) {
        setlatlng(e?.latlng);
        setservice(true);
    }

    function centerMap(e) {
        this.panTo(e.latlng);
    }

    function zoomIn(e) {
        this.zoomIn();
    }

    function zoomOut(e) {
        this.zoomOut();
    }
    function googleMaps(e) {
        window.open(
            `https://maps.google.com/maps?q=${e?.latlng?.lat},${e?.latlng?.lng}&amp;t=m`,
            "_blank"
        );
    }
    function streeView(e) {
        window.open(
            `https://www.google.com/maps?q&layer=c&cbll=${e?.latlng?.lat},${e?.latlng?.lng}`,
            "_blank"
        );
    }
    const map = useMap();
    useEffect(() => {
        contextItems?.length > 0 &&
            contextItems.forEach((element) => {
                map.contextmenu.addItem(element);
            });

        return () => map.contextmenu.removeAllItems();
    }, []);

    return (
        <>
            {service && (
                <ModalServices
                    setshow={setservice}
                    show={service}
                    title={"Creació nou servei"}
                    data={latlng}
                    isNew
                />
            )}

            <style jsx>{``}</style>
        </>
    );
};

export default Maplibs;
