import SlideMenuContext from "../../../contexts/SlideMenuContext";
import useUserContext from "../../../contexts/UserContext";
import Image from "next/image";
import { ModalSettings } from "../../customModals/ModalSettings/ModalSettings";
import { useState } from "react";


const ListaMenuLateral = ({ list }) => {
    const { itemNav, setItemNav, setaction } = SlideMenuContext();
    const { logout } = useUserContext();
    const [account, setaccount] = useState(false);

    const slideMenu = document.getElementById("slideMenu");

    const hiddeSideNav = () =>
        slideMenu.classList.replace("showSideNav", "hiddeSideNav");

    const retardSetItem = (value) =>
        setTimeout(() => {
            setItemNav(value);
        }, 250);

    /*Si click en un item del menu lateral*/
    const handleClick = (e, action, value, modal) => {
        setaction(action);
        //Treure higlight de l'últim seleccionat
        document
            .getElementsByClassName("active")[0]
            ?.classList.toggle("active");

        //Si es el mateix que tanqui i no obri més
        if (itemNav === value && action === "toggle") {
            hiddeSideNav();
            setItemNav(-1);
            setaction("");
            return 0;
        }

        //Definim les possibles funcions
        const actions = {
            logout: () => isLogout(),
            toggle: () => isToggle(),
            modal: () => isModal(),
        };

        ////Implementació de les funcions////
        const isLogout = () => logout();

        const isToggle = () => {
            e.target.classList.toggle("active");
            hiddeSideNav();

            //Si esta abierto cierra de golpe, sinó espera para hacer efecto cerrar-abrir
            itemNav == -1 ? setItemNav(value) : retardSetItem(value);
        };

        const isModal = async () => {
            hiddeSideNav();
            retardSetItem(value);
            modal === "account" && setaccount(true);

            if (modal === "help") {
               /**/                
            }
        };

        //Retornem el document executant l'acció que li toca
        return actions[action]();
    };

    return (
        <ul className="navlistStyle">
            {list.map((item) => (
                <li
                    className="elementList"
                    data-id={item.value}
                    key={item.key}
                    onClick={(e) =>
                        handleClick(e, item.action, item.value, item?.modal)
                    }
                >
                    <a className="navLink">
                        <div className="navLinkContainer">
                            <Image
                                className="iconNavLink"
                                src={item.src}
                                alt={item.alt}
                                height={36}
                                width={36}
                            />
                        </div>
                        <div className="textNavLink">{item.text}</div>
                    </a>
                </li>
            ))}

            {!!account && (
                <ModalSettings
                    setshow={setaccount}
                    show={account}
                    title={"Configuració"}
                />
            )}

            <style jsx>{`
                ul > li .active {
                    background-color: var(--primaryBlue);
                }
                .navlistStyle {
                    margin: 0;
                    list-style: none;
                    padding-left: 0;
                    margin-top: 0;
                    display: block;
                }

                .navLink {
                    cursor: pointer;
                    -webkit-box-align: center;
                    align-items: center;
                    color: var(--textButton);
                    display: -webkit-box;
                    display: flex;
                    -webkit-box-orient: vertical;
                    -webkit-box-direction: normal;
                    flex-direction: column;
                    height: 5rem;
                    -webkit-box-pack: center;
                    justify-content: center;
                    margin: 0 auto;
                    text-decoration: none;
                    background-color: transparent;
                }
                .navLink:hover {
                    color: var(--textButton);
                    text-decoration: none;
                    cursor: pointer;
                }

                .navLinkContainer {
                    height: 2.25rem;
                    color: var(--textButton);
                    pointer-events: none;
                }

                .iconNavLink {
                    pointer-events: none;
                    user-select: none;
                }

                .textNavLink {
                    letter-spacing: 1.5px;
                    font-weight: 400;
                    line-height: 1.4;
                    color: #fff;
                    font-size: 0.875rem;
                    padding: 3px 0.375rem;
                    text-align: center;
                    pointer-events: none;
                    user-select: none;
                }

                /*Landscape & Portrait*/
                @media (max-width: 600px), (max-height: 600px) {
                    .navlistStyle {
                        display: flex;
                        flex-direction: row;
                        flex-wrap: wrap;
                        justify-content: center;
                    }
                    .navLink {
                        border: 1px solid var(--background);
                    }

                    .elementList {
                        width: 48%;
                        padding-top: 15px;
                        padding-left: 15px;
                        max-width: 20rem;
                        box-sizing: border-box;
                    }
                }
            `}</style>
        </ul>
    );
};

export default ListaMenuLateral;
