import { useEffect } from "react";
import ObjectsContext from "../../../../../contexts/ObjectsContext";
import { toast } from "react-toastify";

const map = new Map();

const CheckEvents = ({ setevents, events }) => {
    // let noti = new Audio("./tono.mp3", 30, true);
    // noti.volume = 0.2;
    // noti.muted = true;

    const { objects /*,setObjects*/ } = ObjectsContext();
    const items = { speed: false, fuel: false, unplugged: false };
    useEffect(() => {
        objects?.data?.length &&
            objects.data.map((o) => {
                const key = o?.object?._id;
                const collection = map.get(key);

                if (!collection) {
                    map.set(key, items);
                    collection = map.get(key);
                }

                if (o?.properties?.gps?.speed >= 90 && !collection.speed) {
                    map.set(key, {
                        ...map.get(key),
                        speed: true,
                    });

                    toast.warn(
                        `${o?.object?.name} — Velocitat superior a 90km/h`
                    );

                    setevents((prevState) => {
                        if (prevState?.length > 14) {
                            prevState?.shift();
                        }
                        prevState.push(
                            `${o?.object?.name} — Velocitat superior a 90km/h`
                        );
                        return prevState;
                    });
                } else if (o?.properties?.gps?.speed < 90) {
                    map.set(key, {
                        ...map.get(key),
                        speed: false,
                    });
                }

                if (
                    o?.properties?.ioElements?.fuel > 0 &&
                    o?.properties?.ioElements?.fuel <= 20 &&
                    !collection.fuel
                ) {
                    map.set(key, {
                        ...map.get(key),
                        fuel: true,
                    });

                    toast.warn(
                        `${o?.object?.name} — Combustible per sota del 20%`
                    );

                    setevents((prevState) => {
                        if (prevState?.length > 14) {
                            prevState?.shift();
                        }
                        prevState.push(
                            `${o?.object?.name} — Combustible per sota del 20%`
                        );
                        return prevState;
                    });
                } else if (o?.properties?.ioElements?.fuel > 20) {
                    map.set(key, {
                        ...map.get(key),
                        fuel: false,
                    });
                }

                if (o?.properties?.event_id === 1 && !collection.unplugged) {
                    map.set(key, {
                        ...map.get(key),
                        unplugged: true,
                    });

                    toast.warn(
                        `${o?.object?.name} — Combustible per sota del 15%`
                    );

                    setevents((prevState) => {
                        if (prevState?.length > 14) {
                            prevState?.shift();
                        }
                        prevState.push(
                            `${o?.object?.name} — Combustible per sota del 15%`
                        );
                        return prevState;
                    });
                } else if (o?.properties?.event_id === 0) {
                    map.set(key, {
                        ...map.get(key),
                        unplugged: false,
                    });
                }
            });
    }, [objects]);

    return null;
};

export default CheckEvents;
