import {  Tab, Tabs } from "react-bootstrap";

import Servei from "./Servei";

import ServeisContext from "../../../../../contexts/ServeisContext";
import Tabampliada from "./TabAmpliada";


const Serveis = () => {
    const { serveis } = ServeisContext();

    let openTras = [];
    let closed = [];

    if (serveis?.length > 0) {
        closed = serveis.filter((servei) => servei.status == "closed");
        openTras = serveis.filter((servei) =>
            ["traspas", "open"].includes(servei.status)
        );
    }

    return (
        <div>
            <Tabs
                defaultActiveKey="obertsTab"
                id="serveisTabs"
                className="mb-3"
            >
                <Tab eventKey="obertsTab" title="Oberts">
                    <center>
                        <h4>Ultimes 24 hores</h4>
                    </center>
                    {openTras?.length > 0 &&
                        openTras?.map((servei) => {
                            return <Servei servei={servei} key={servei._id} />;
                        })}
                    {openTras?.length <= 0 && (
                        <h5>No hi ha cap servei obert</h5>
                    )}
                </Tab>
                <Tab eventKey="tancatsTab" title="Tancats">
                    <center>
                        <h4>Ultimes 24 hores</h4>
                    </center>
                    {closed?.length > 0 &&
                        closed?.map((servei) => {
                            return <Servei servei={servei} key={servei._id} />;
                        })}
                    {closed?.length <= 0 && <h5>No hi ha cap servei tancat</h5>}
                </Tab>
                <Tab eventKey="ampliadaTab" title="Cerca Ampliada">
                    <Tabampliada />
                </Tab>
            </Tabs>

            <style jsx>{``}</style>
        </div>
    );
};

export default Serveis;
