import ListaMenuLateral from "./ListaMenuLateral";
import { navTop, navBottom } from "./itemsMenu";

const VerticalMenu = () => {
    return (
        <nav className="verticalMenu">
            <div className="groupNav">
                <ListaMenuLateral list={navTop} />
            </div>
            <div className="groupNavBottom">
                <ListaMenuLateral list={navBottom} />
            </div>
            <style jsx>{`
                .verticalMenu {
                    box-shadow: 0 0 0.5rem rgb(0 0 0 / 75%);
                    z-index: 50;
                    position: fixed;
                    height: 100%;
                    min-height: 375px;
                    width: 5rem;
                    display: block;
                    background-color: var(--verticalMenu);
                    padding-top: 0.1rem;
                    /* font-family: Open Sans; */
                }

                .groupNavBottom {
                    bottom: 0px;
                    position: absolute;
                    width: -webkit-fill-available;
                }

                /*Landscape & Portrait*/
                @media (max-width: 600px), (max-height: 600px) {
                    .verticalMenu {
                        visibility: hidden;
                        transition: 0s;
                        margin-top: 3.75rem;                        
                        position:absolute;
                        width: 100%;
                        height: 100%;                        
                    }
                    .verticalMenu.visibleM {
                        visibility: visible;                        
                        transition: 0.3s;
                        display: grid;
                        grid-template-rows: 50% 50%;
                        z-index:1;
                    }
                    .groupNav {
                        margin-top:1.5rem;
                        grid-row: 1;
                    }
                    .groupNavBottom {
                        grid-row: 2;
                        position: relative;
                        
                    }
                }
            `}</style>
        </nav>
    );
};

export default VerticalMenu;
