import { Button } from "../globals/Button";
import styles from "../../styles/signUp.module.css";
import { ModalClose } from "../globals/ModalClose";
import { useState } from "react";

const EmailNotVerified = ({ user }) => {
    const handleClickbutton = () => {
        console.log({ user });
        user.sendEmailVerification().then(() => {
            setmodalSendEmail(true);
        });
    };

    const [modalSendEmail, setmodalSendEmail] = useState(false);
    
    return (
        <div className="notEmailVerifiedContainer">
            <div style={{ maxWidth: "500px" }}>
                <div className="titleNotEmailVerified">
                    Compte de correu no verificada
                </div>
                <div className={styles.card}>
                    <p>
                        La vostra adreça de correu electrònic no ha estat
                        verificada. Primer s&lsquo;ha de validar per a poder
                        utilitzar la plataforma.
                    </p>
                    <p>
                        Si no observes el missatge de verificació a la safata
                        d&lsquo;entrada, potser hauries de fer un cop
                        d&lsquo;ull a la carpeta d&lsquo;SPAM
                    </p>
                    <p> Encara no has rebut el correu?</p>
                    <div className="mt-4 d-flex justify-content-center">
                        <Button onClick={handleClickbutton}>
                            Reenviar correu
                        </Button>
                    </div>
                </div>
            </div>

            <style jsx>{`
                .notEmailVerifiedContainer {
                    padding: 0em 0;
                    flex: 1;
                    display: flex;
                    flex-direction: column;
                    justify-content: center;
                    align-items: center;
                    margin-top: 50px;
                }
                .titleNotEmailVerified {
                    text-align: center;
                    font-size: x-large;
                    font-weight: 400;
                    margin: 1rem;
                }
                p {
                    font-size: 1rem;
                    margin-top: 15px;
                    text-align: justify;
                }
                /*Landscape & Portrait*/
                @media (max-width: 600px), (max-height: 600px) {
                    .notEmailVerifiedContainer {
                        margin-top: 70px;
                    }
                }
            `}</style>
            <ModalClose
                centered
                setshow={setmodalSendEmail}
                show={modalSendEmail}
                title={"Operació realitzada correctament"}
                text={
                    "S'ha enviat un enllaç al correu elèctronic per verificar la teva adreça, segueixi les intruccions enviades per finalitzar el registre"
                }
                route="/"
            />
        </div>
    );
};

export default EmailNotVerified;
