/**
 * Capçal de la pàgina SignUp.
 * Torna a la pàgina principal fent click als logos
 */

import styles from "../../styles/signUp.module.css";
import TitleSVG from "../../components/globals/TitleSVG";
import Link from "next/link";
import Image from "next/image";

export const SignUpHeader = () => {
    return (
        <header>
            <div className={styles.registerHeader}>
                <Link href="/" passHref>
                    <div className={styles.tileLogo}>
                        <TitleSVG width={200} height={50} cursor="pointer" />
                    </div>
                </Link>
                <Link href="/" passHref>
                    <div className={styles.imageLogo}>
                        <Image
                            width="40pt"
                            height="40pt"
                            src="/logo.svg"
                            alt="Logotip de l'aplicació"
                        />
                    </div>
                </Link>
            </div>
        </header>
    );
};
