import React, { useContext, createContext } from "react";

//Context
export const AppContext = createContext();

//Provider
export const AccountContextProvider = ({ children }) => {
    const [account, setAccount] = React.useState({});
    
    //ComponentDidMouunt
    React.useEffect(() => {}, []);

    //
    const values = React.useMemo(
        () => ({
            account, // States que seran visibles en el contexto.
            setAccount, // Funciones que son exportadas para manejo externo.                       
        }),
        [account]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//
export function AccountContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying item Context!!!");
    }

    return context;
}

export default AccountContext;
