import React, { useContext, createContext } from "react";

//Context
export const AppContext = createContext();

//Provider
export const MapContextProvider = ({ children }) => {
    const [map, setmap] = React.useState();
    

    //ComponentDidMouunt
    React.useEffect(() => {}, []);

    //
    const values = React.useMemo(
        () => ({
            map, // States que seran visibles en el contexto.
            setmap, // Funciones que son exportadas para manejo externo.                       
        }),
        [map]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//
export function MapContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying item Context!!!");
    }

    return context;
}

export default MapContext;
