import React, { useContext, createContext } from "react";

//Context
export const AppContext = createContext();

//Provider
export const ObjectsContextProvider = ({ children }) => {
    const [objects, setObjects] = React.useState({});
    

    //ComponentDidMouunt
    React.useEffect(() => {}, []);

    //
    const values = React.useMemo(
        () => ({
            objects, // States que seran visibles en el contexto.
            setObjects, // Funciones que son exportadas para manejo externo.                       
        }),
        [objects]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//
export function ObjectsContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying item Context!!!");
    }

    return context;
}

export default ObjectsContext;
