import React, { useContext, createContext } from "react";
import useUserContext from "./UserContext";

//Context
export const AppContext = createContext();

//Provider
export const ServeisContextProvider = ({ children }) => {
    const [serveis, setserveis] = React.useState();
    const { user } = useUserContext();


    //ComponentDidMouunt
    React.useEffect(() => {
        
    }, [user]);
    //
    const values = React.useMemo(
        () => ({
            serveis, // States que seran visibles en el contexto.
            setserveis, // Funciones que son exportadas para manejo externo.                       
        }),
        [serveis]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//
export function ServeisContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying item Context!!!");
    }

    return context;
}

export default ServeisContext;
