/**
 * Context que guarda un usuari i el manté accessible
 * desde qualsevol lloc de l'aplicació.
 */

import React, { useContext, createContext } from "react";
import { useUser } from "../Hooks/useUser";

//Context
export const AppContext = createContext();

//Provider
export const UserContextProvider = ({ children }) => {
    const { user, setUser, logout } = useUser();

    //ComponentDidMouunt
    React.useEffect(() => {}, []);
    
    const values = React.useMemo(
        () => ({
            user, // States que seran visibles en el contexto.
            setUser,
            logout // Funciones que son exportadas para manejo externo.
        }),
        [user]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//Hook
export function useUserContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying User Context!!!");
    }

    return context;
}

export default useUserContext;
