import React, { useContext, createContext } from "react";

//Context
export const AppContext = createContext();

//Provider
export const ZonesContextProvider = ({ children }) => {
    const [zones, setzones] = React.useState({});
    
    //ComponentDidMouunt
    React.useEffect(() => {}, []);

    //
    const values = React.useMemo(
        () => ({
            zones, // States que seran visibles en el contexto.
            setzones, // Funciones que son exportadas para manejo externo.                                   
        }),
        [zones]
    ); // States que serán visibles en el contexto.

    // Interface donde será expuesto como proveedor y envolverá la App.
    return <AppContext.Provider value={values}>{children}</AppContext.Provider>;
};

//
export function ZonesContext() {
    const context = useContext(AppContext);

    if (!context) {
        console.error("Error deploying item Context!!!");
    }

    return context;
}

export default ZonesContext;
