import mongoose from "mongoose";

const { Schema } = mongoose;

const ObjectId = mongoose.Types.ObjectId;

const objects = mongoose.Schema(
    {
        value: { type: ObjectId, ref: "Object", default: "" },
        label: { type: String, default: "" },
    },
    { _id: false }
);

//Schema que gestiona les entitats
const serviceSchema = new Schema({
    // _id: ObjectId,
    idEntity: {
        type: ObjectId,
        ref: "Entity",
        required: true,
    },
    idUserInit: {
        type: String,
        ref: "Account",
        required: true,
    },
    idUserClosed: {
        type: ObjectId,
        ref: "Account",
    },
    title: { type: String, required: true, default: "" },
    dateInput: {
        type: Date,
        default: Date.now,
    },
    dateAssign: {
        type: Date,
        default: "",
    },
    dateFinish: {
        type: Date,
        default: "",
    },
    geometry: {
        type: { type: String, default: "Point" },
        coordinates: { type: [Number], default: [1.8097316, 41.7211933] }, //Centre Catalunya
    },
    direction: { type: String, default: "" },
    service: { type: String, default: "" },
    result: { type: String, default: "" },
    status: { type: String, default: "open" },
    objects: [objects],
});
//Index per fer les cerques per entitat  i per temps
serviceSchema.index({ idEntity: 1, dateInput: 1 });

export default mongoose.models.Service ||
    mongoose.model("Service", serviceSchema);
