import mongoose from "mongoose";

const { Schema } = mongoose;

//Schema que gestiona els comptes
const UnitatSchema = new Schema({
    type: String,
    geometry: {
        type: { type: String, default: "Point" },
        coordinates: { type: [Number], default: [0, 0] },
    },
    properties: {
        imei: String,
        // type:       String,
        event_id: Number,
        timestamp: Date,
        gps: {
            altitude: Number,
            angle: Number,
            speed: Number,
            satellites: Number,
            precision: Number,
        },
        ioElements: {
            battery: Number,
            battery_device: Number,
            ignition: Boolean,
            gsm_strengh: Number,
            fuel: Number,
        },
    },
});
//Index per fer les cerques per imei i per temps
UnitatSchema.index({ "properties.imei": 1, "properties.timestamp": 1 });

export default mongoose.models.Unitat || mongoose.model("Unitat", UnitatSchema);
