import mongoose from "mongoose";

const { Schema } = mongoose;

const ObjectId = mongoose.Types.ObjectId;

const zoneSchema = new Schema({
    idEntity: {
        type: ObjectId,
        ref: "Entity",
    },
    idAccount: { type: String, default: "" },
    name: { type: String, default: "" },
    description: { type: String, default: "" },
    group: { type: String, default: "" },
    color: { type: String, default: "#1343de" },
    visible: { type: Boolean, default: true },
    type: { type: String, default: "Point" },
    coordinates:  [[Number]],   
    radius:{ type: Number, default: 0 },
    created: {
        type: Date,
        default: Date.now,
    },
});

export default mongoose.models.Zone || mongoose.model("Zone", zoneSchema);
