/**
 * Carrega els recursos globals i crea un context envolvent a tota 
 * l'aplicació per a carregar l'usuari identificat. 
 */

import "../styles/globals.css";
import "bootstrap/dist/css/bootstrap.css";
import Head from "next/head";
import { UserContextProvider } from "../contexts/UserContext";
import initFirebase from "../utils/auth/initFirebase";
import React from "react";



function MyApp({ Component, pageProps }) {

    initFirebase();

    return (
        
        <div className="App">
            
            <Head>
                <title>Police Tracker</title>
                <link rel="icon" href="/favicon.ico" />
              
            </Head>
            {/* context */}
            <UserContextProvider >               
              <Component {...pageProps} />
            </UserContextProvider>
        </div>
        
    );
}
export default MyApp;
