import { firebaseAdmin } from "../../../utils/auth/firebaseAdmin";

//EXAMPLE GET
// http://localhost:3000/api/auth/checkUserByEmail?email=rulomo@yahoo.es

const checkUserByEmail  = async (req, res) => {

    let email;    

    if (req.method == "GET") {
        email  = req.query.email         
    } else if (req.method == "POST") {
        email  = (req.body.email)        
    }else{
        req.json({});
    }
    Object.freeze(email);

    function checkUserInFirebase(pEmail) {
        return new Promise((resolve) => {
            firebaseAdmin
                .auth()
                .getUserByEmail(pEmail)
                .then((user) => {
                    resolve({
                        isError: false,
                        doesExist: true /*, user */,
                    });
                })
                .catch((err) => {
                    resolve({ isError: true, err });
                    console.error("User not found")
                });
        });      

    }
    const rFirebase = await checkUserInFirebase(email);
    res.json(rFirebase);    
};

export default checkUserByEmail;
