/**
 * Crea un usuari nou a Firebase i a Mongo
 * Si falla algun dels dos fa RollBack i borra tot
 * També envia un correu de verificació a l'adreça indicada.
 * L'enviament del correu no influeix, es fa en asincron, si falla
 * aquest enviament es grava l'usuari igualment, es pot demanar tornar a
 * enviar si s'entra sense estar verificat.
 */

import Account from "../../../models/Account";
import { connectToDatabase } from "../../../utils/db/mongodb";
import { withAuth } from "../../../utils/lib/middlewares";
import { sendJsonResponse } from "../../../utils/lib/responseServer";

const directionsData = async (req, res) => {
    //Connect mongoose to DB
    await connectToDatabase();
    const method = req.method;
    const { data: pdata } = req.body || false;
    const user_id = req?.user_id;
    //Cercar a la BBDD el compte que fa l'acció a partir del id l'usuari
    const accountSet = await Account.findById(user_id).exec();

    //Definim les possibles funcions
    const actions = {
        GET: () => isGET(),
        POST: () => isPUT(),
        PUT: () => isPUT(),
        DELETE: () => isDELETE(),
    };

    ////Implementació de les funcions////

    const isPUT = async () => {
        try {
            const direction = {
                place_name: pdata?.place_name,
                text: pdata?.text,
                address: pdata?.address,
                geometry: pdata?.geometry,
            };
            if (pdata?.action === "last") {
                if (accountSet?.directions?.[`${pdata?.action}`]?.length > 5) {
                    accountSet?.directions?.[`${pdata?.action}`]?.shift();
                }
            }
            accountSet?.directions?.[`${pdata?.action}`]?.push(direction);

            const account = await accountSet.save();

            sendJsonResponse(res, 200, { accion: true, data: account });
        } catch (error) {
            sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };
    const isDELETE = async () => {
        try {
            
            const index = accountSet?.directions?.[
                `${pdata?.action}`
            ]?.findIndex(d => d?._id == pdata?._id);
            
            if (index > -1) {
                accountSet?.directions?.[`${pdata?.action}`]?.splice(index, 1);
            }

            const account = await accountSet.save();

            sendJsonResponse(res, 200, { accion: true, data: account });
        } catch (error) {
            console.log(error);
            sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };

    return actions[method]();
};

export default withAuth(directionsData);
