/**
 *
 *
 */

import Account from "../../../models/Account";
import Object from "../../../models/Object";
import Unitat from "../../../models/Unitat";
import { connectToDatabase } from "../../../utils/db/mongodb";
import { sendJsonResponse } from "../../../utils/lib/responseServer";
import { withAuth, withRoles } from "../../../utils/lib/middlewares";

const historicData = async (req, res) => {
    //Connect mongoose to DB
    await connectToDatabase();
    const method = req.method;
    const { data: pdata } = req.body || false;
    const user_id = req?.user_id;
    //Cercar a la BBDD el compte que fa l'acció a partir del id l'usuari
    const accountSet = await Account.findById(user_id).lean();

    //Definim les possibles funcions
    const actions = {
        GET: () => isGET(),
        POST: () => isPOST(),
        PUT: () => isPUT(),
        DELETE: () => isDELETE(),
    };

    ////Implementació de les funcions////
    const isGET = async () => {
        let {
            query: { id, minutes },
        } = req;
        try {
            const object = await Object.findById(id);

            let dFinal = new Date();

            dFinal.setMinutes(dFinal.getMinutes());

            let dInici = new Date();

            dInici.setMinutes(dInici.getMinutes() - minutes);

            const unitats = await Unitat.find({
                "properties.imei": object?.IMEI,
                "properties.timestamp": { $gte: dInici, $lte: dFinal },
            }).sort({"properties.timestamp": 1}).exec();

            sendJsonResponse(res, 200, { accion: true, data: unitats});

        } catch (error) {
            console.log(error);
            sendJsonResponse(res, 500, {
                accion: false,
                err: "no es poden obtenir les dades sol·licitades",
            });
        }
    };

    const isPUT = async () => {
      
    };

    const isPOST = async () => {
      
    };

    const isDELETE = async () => {
      
    };

    return actions[method]();
};
export default withAuth(historicData);
