/**
 *
 *
 */

import Account from "../../../models/Account";

import { connectToDatabase } from "../../../utils/db/mongodb";
import { sendJsonResponse } from "../../../utils/lib/responseServer";
import { withAuth } from "../../../utils/lib/middlewares";

const mapconf = async (req, res) => {
    //Connect mongoose to DB
    await connectToDatabase();
    const method = req.method;
    const { data: pdata } = req.body || false;
    const user_id = req?.user_id;
    //Cercar a la BBDD el compte que fa l'acció a partir del id l'usuari
    const accountSet = await Account.findById(user_id).lean();

    //Definim les possibles funcions
    const actions = {
        GET: () => isGET(),
        POST: () => isPOST(),
        PUT: () => isPUT(),
        DELETE: () => isDELETE(),
    };

    ////Implementació de les funcions////
    const isGET = async () => {
        return sendJsonResponse(res, 403, {
            accion: false,
            err: "no es poden obtenir les dades sol·licitades",
        });
    };

    const isPUT = async () => {
        try {
            //Fields to update
            let updateData = {
                'map.geometry.coordinates':[pdata?.lon,pdata?.lat],
                // 'map.geometry.coordinates[1]':,
                'map.zoom': pdata?.zoom,
                'map.layer': pdata?.layer,
                'map.geocoding': pdata?.geocoding,
                'map.scrollWheelZoom': pdata?.scrollWheelZoom,
                }
            //Update object in BBDD
            Account.findByIdAndUpdate(
                accountSet._id,
                updateData,
                {
                    new: true,
                },
                (err, conf) => {                 
                    !err
                        ? sendJsonResponse(res, 200, {
                              accion: true,
                              data: conf,
                          })
                        : sendJsonResponse(res, 500, {
                              accion: false,
                              err: err,
                          });
                }
            );
        } catch (error) {
            return sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };

    const isPOST = async () => {
        return sendJsonResponse(res, 405, {
            accion: false,
            err: "Metode no permès",
        });
    };

    const isDELETE = async () => {
        return sendJsonResponse(res, 405, {
            accion: false,
            err: "Metode no permès",
        });
    };

    return actions[method]();
};
export default withAuth(mapconf);
