/**
 *
 *
 */

import Account from "../../../models/Account";
import Object from "../../../models/Object";
import { connectToDatabase } from "../../../utils/db/mongodb";
import { sendJsonResponse } from "../../../utils/lib/responseServer";
import { withAuth, withRoles } from "../../../utils/lib/middlewares";
import Entity from "../../../models/Entity";
import mongoose from "mongoose";
import Zone from "../../../models/Zone";

const zonesData = async (req, res) => {
    //Connect mongoose to DB
    await connectToDatabase();
    const method = req.method;
    const { data: pdata } = req.body || false;
    const user_id = req?.user_id;
    //Cercar a la BBDD el compte que fa l'acció a partir del id l'usuari
    const accountSet = await Account.findById(user_id).lean();

    //Definim les possibles funcions
    const actions = {
        GET: () => isGET(),
        POST: () => isPOST(),
        PUT: () => isPUT(),
        DELETE: () => isDELETE(),
    };

    ////Implementació de les funcions////
    const isGET = async () => {
        try {
            const zones = await Zone.find({
                idEntity: accountSet?.idEntity,
            });

            let tmp = {
                main: {
                    polygons: [],
                    marks: [],
                },
                entity: {
                    polygons: [],
                    marks: [],
                },
            };
            if (zones?.length > 0) {
                zones?.map((z) => {
                    if (z?.idAccount == accountSet._id) {
                        if (z?.type === "marker") {
                            tmp.main.marks.push(z);
                        } else {
                            tmp.main.polygons.push(z);
                        }
                    } else {
                        if (z?.type === "marker") {
                            tmp.entity.marks.push(z);
                        } else {
                            tmp.entity.polygons.push(z);
                        }
                    }
                });
            }

            sendJsonResponse(res, 200, {
                accion: true,
                data: tmp,
            });
        } catch (error) {
            sendJsonResponse(res, 500, {
                accion: false,
                err: "no es poden obtenir les dades sol·licitades",
            });
        }
    };

    const isPUT = async () => {
        try {
        } catch (error) {
            return sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };

    const isPOST = async () => {
        try {
            pdata.idEntity = accountSet?.idEntity;
            pdata.idAccount = accountSet?._id;

            const zone = new Zone(pdata);

            zone.save();

            sendJsonResponse(res, 200, {
                accion: true,
                data: zone,
            });
        } catch (error) {
            console.log(error);
            return sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };

    const isDELETE = async () => {
        try {
            if (accountSet._id != pdata.idAccount) {
                if (!accountSet.admin) {
                    return sendJsonResponse(res, 500, {
                        accion: false,
                        err: "Privilegis insuficients",
                    });
                }
            }
            const zone = await Zone.findByIdAndDelete(pdata?._id);
            sendJsonResponse(res, 200, {
                accion: zone ? true : false,
                data: zone,
            });
        } catch (error) {
            console.log(error);
            return sendJsonResponse(res, 500, {
                accion: false,
                err: error,
            });
        }
    };

    return actions[method]();
};
export default withAuth(zonesData);
