import { connectToDatabase } from "../../utils/db/mongodb";
import { firebaseAdmin } from "../../utils/auth/firebaseAdmin";

//Comprova el token per veure si correspon algun usuari
const returnUserByToken = async  (token) => {
    //Connect mongoose to DB
    await connectToDatabase();
    return new Promise((resolve) => {
        if (!!token) {
            firebaseAdmin
                .auth()
                .verifyIdToken(token)
                .then((user) => {
                    const { user_id } = user;
                    resolve({
                        isTokenOK: true,
                        user_id /*, user */,
                    });
                })
                .catch((err) => {
                    resolve({ isTokenOK: false, user_id: false, err });
                });
        } else {
            resolve({ isTokenOK: false, user_id: false });
        }
    });
}

const notFound =  (req, res) => {
    return  res.status(404).send();
};

export default notFound;


export  {returnUserByToken};



