/**
 * Pagina principal que es carrega quan s'entra.
 * Comprova si hi ha algun usuari identificat i entra
 * al main, sino, carrega la pagina de login.
 */

import { Login } from "../components/login/Login";
import useUserContext from "../contexts/UserContext";
import { useEffect } from "react";
import { useRouter } from "next/router";

export default function Home(usuario) {
    const router = useRouter();

    const { user } = useUserContext(undefined);

    useEffect(() => {
        //Si login i email verificat entra a la app
        user && router.push("/app");

    }, [router, user]);

    useEffect(() => {
        // Prefetch the app page
        router.prefetch("/app");
    }, [router]);

    //No login pagina de login
    return <>{!user && <Login />}</>;
}
