/**
 * Pàgina que conté els formularis per a donar un nou usuari d'alta
 * Consta de dos pagines, una per introduïr el Email i comprovar que sigui 
 * correcte, i un altre per acabar d'introduïr totes les dades. Amb 
 * l'estat emailCheck s'avança a la segona pagina. 
 */


import { useForm } from "../Hooks/useForm";
import { EmailCheck } from "../components/register/EmailCheck";
import { SignUpHeader } from "../components/register/SignUpHeader";
import { useState } from "react";
import { AllDataCheck } from "../components/register/AllDataCheck";



export default function SignUp() {
    //camps inicials del formulari
    const initialForm = {
        displayName: "",
        email: "",
        cEmail: "",
        password: "",
        cPassword: "",
        type: "",
        admin:true,     //Es fa desde el formulari sempre serà admin i main
        main:true
    };

    const [emailCheck, setemailCheck] = useState(false);

    const [formValues, handleInputChange ,reset] = useForm(initialForm);

    return (
        <main>
            <SignUpHeader />
            {/* primera pagina, només email */}
            {!emailCheck && (
                <EmailCheck
                    handleInputChange={handleInputChange}
                    formValues={formValues}
                    setemailCheck={setemailCheck}
                    reset={reset}
                />
            )}
            {/* resta de dades */}
            {emailCheck && (
                <AllDataCheck
                    handleInputChange={handleInputChange}
                    formValues={formValues}
                />
            )}
        </main>
    );
}
