import * as firebaseAdmin from "firebase-admin";

const privateKey = process.env.FIREBASE_PRIVATE_KEY.replace(/\\n/g, "\n");
const clientEmail = process.env.CLIENT_EMAIL;
const projectId = process.env.FIREBASE_PROJECT_ID;

// get this JSON from the Firebase board
// you can also store the values in environment variables


if (!firebaseAdmin.apps.length) {    
    firebaseAdmin.initializeApp({
        credential: firebaseAdmin.credential.cert({
            privateKey: privateKey,
            clientEmail: clientEmail,
            projectId: projectId,
        }),
        databaseURL: `https://${projectId}.firebaseio.com`,
    });
}

export { firebaseAdmin };
